﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net.Sockets;
using System.IO;

namespace GrabServers
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        Random rand = new Random();
        string[] searchWords = new string[] { "books","toys","medicine","math", "programming", "sports", "news", "kids", "cars","religon", "English","jokes", "universities", "magazines", "travel", "homes" };
         
        protected void Page_Load(object sender, EventArgs e)
        {
            DataTable dtsum = (DataTable)Session["summaryTable"]; ;
            DataTable dt = (DataTable)Session["urlTable"];
            if (dt==null) 
            {   dt = new DataTable();
                dt.Columns.Add("SeqNo", System.Type.GetType("System.Int16"));
                dt.Columns.Add("URL", System.Type.GetType("System.String"));
                dt.Columns.Add("ServerInfo", System.Type.GetType("System.String"));
               
                Session["urlTable"] = dt;

                // Set URL column as the PrimaryKey to prevent dublicate URLs
                DataColumn[] keys = new DataColumn[1];
                keys[0] = dt.Columns[1];
                dt.PrimaryKey = keys;
                
                // Also, create Summary table
                dtsum = new DataTable();

                dtsum.Columns.Add("ServerInfo", System.Type.GetType("System.String"));
                dtsum.Columns.Add("Count", System.Type.GetType("System.Int16"));
               
                Session["summaryTable"] = dtsum;

            }
             
             string searchWord = searchWords[rand.Next(searchWords.Length)];
            
           // string SearchUrl = String.Format("http://www.google.com/search?q={0}", HttpUtility.UrlDecode(SearchTerm));
            string SearchUrl =  "http://www.google.com/search?q=" + searchWord;
                                        
            string searchData = FetchURL(SearchUrl,"GET");

            if (searchData.StartsWith("Error"))
            {   Response.Write(searchData);
                Response.End();
                return;
            }
              
            // Debugging: Response.Write(searchData);  return;

            HashSet<string> urlSet = ProcessData(searchData);

            foreach (string s in urlSet)
            {   DataRow row1 = dt.NewRow();
                row1["SeqNo"] = dt.Rows.Count + 1;
                row1["URL"] = s;
                row1["ServerInfo"] = "Unknown";

                // Note: Adding a duplicate URL causes exception
                // We use try with empty catch to simply ignore the error and continue
                // (like VB statement: On Error Resume Next) 
                try { dt.Rows.Add(row1); }
                catch { };
            }

            // Response.Write("Rows count = " + dt.Rows.Count +  "; Refresh the page for more ...");

            Label1.Text = "Rows count = " + dt.Rows.Count + "; Refresh the page for more ...";
             
            int MaxRecords = 10;
            ModifyServerInfo(dt, dtsum, MaxRecords);
  
            // Last Step: Set DataSource for GridView and Bind

             GridView1.DataSource = dt; 
             GridView1.DataBind();
             
             dtsum.DefaultView.Sort = "Count Desc"; 
             GridView2.DataSource = dtsum;
             GridView2.DataBind();
         
        }
         

        string FetchURL(string url, string requestMethod)
        {
            int doubleSlahIndex = url.IndexOf("//");

            if (doubleSlahIndex > 0)
            {  // Remove protocol part
                doubleSlahIndex += 2;
                url = url.Substring(doubleSlahIndex);
            }


            string host = url;
            string path = "/";

            int pathIndex = url.IndexOf('/');

            if (pathIndex > 0)
            {   host = url.Substring(0, pathIndex);
                path = url.Substring(pathIndex);
            }

            //  Response.Write("path:" + path + "*");
            //  Response.Write("host:" + host + "*");

            int port = 80; 
           
            TcpClient client = new TcpClient(host, port);

            NetworkStream stream = client.GetStream();
            StreamReader reader = new StreamReader(stream);
            StreamWriter writer = new StreamWriter(stream);
            // or use StreamReader reader = new StreamReader(stream, Encoding.Default);

           // string command = requestMethod + " " + path + " HTTP/1.0" + "\r\n";

            // some servers respond weirdly if Host or Accept headers are not sent

            string command = "GET " + path + " HTTP/1.0\r\n" + "Accept: */*\r\n" + "Host:" + host + "\r\n";
             
            string output = "";

            // anything can happen when sending/receiving through network
            try
            {   writer.WriteLine(command); // Send
                writer.Flush();
                output = reader.ReadToEnd(); // Receive
            }
            catch (Exception e)
            { output = "Error:" + e.Message; }
             
            return output;
        }


        HashSet<string> ProcessData(string htmlData)
        {  // Extarcts absolute URLs from htmlData
            HashSet<string> urlSet = new  HashSet<string> ();  // Our set for URLs

            int pos = 0; // Track "From" position for searching htmlData 
            while (true)
            {  
              int i = htmlData.IndexOf("http://", pos);

              if (i < 0) break;
                 
              // Search for " (0x22)  or ' (0x27)  or sp  or > starting form i+7 
              int j = i+7;
             
              while (true)
              {
                  if (j >= htmlData.Length) break;
                  if (htmlData[j] == '/') break; // for our purpose, we only need the DomainName part from the url
                  if (htmlData[j] == ' ') break;
                  if (htmlData[j] == '>') break;
                  if (htmlData[j] == (char)0x22) break;
                  if (htmlData[j] == (char)0x27) break;

                  j++;

              } 

              string URL = htmlData.Substring(i, j - i );

              //  For debugging: Response.Write("<br>" + URL + "*");
               
              // Parsing above may still get long URLs and these we want to ignore

               if  (URL.Length < 30)  urlSet.Add(URL);
                 
               pos = j; // Move forward on searching htmlData
             }

            return urlSet;
         }



        void ModifyServerInfo(DataTable dt, DataTable dtsum, int MaxRecords)
        {
           // This method implenents the following steps:
           // 1. Access a random subset of "unknown" records from urlTable 
           // 2. Get Server Headers (using HEAD request) 
           // 3. Modify Server field in urlTable  
           // Note: To limit the time taken by this method, we use MaxRecords (or could use a MaxTime) parameter

            for (int k = 0; k < MaxRecords; k++)
            {   
                int SeqNo = rand.Next(dt.Rows.Count)+1;

                // Use the Select method to find all rows matching the filter.
                DataRow[] foundRows = dt.Select("SeqNo = " + SeqNo);

                // Response.Write("Random Name:" +  foundRows[0]["URL"] );
                
                string ServerInfo = (string)foundRows[0]["ServerInfo"];

                if (!ServerInfo.Equals("Unknown")) continue;
                 
                string Host = (string) foundRows[0]["URL"];

                string HostData = FetchURL(Host, "HEAD");
                // Response.Write("HostData:" + HostData);
                if (HostData.StartsWith("Error"))
                {   Response.Write(HostData);
                    Response.End();
                    return;
                }

                ServerInfo = "*****";
                int i = HostData.IndexOf("Server:");

                if (i < 0) i = HostData.IndexOf("Server");

                if (i >= 0)
                {   i = i+7;
                    int j = i;

                    while (true)
                    {   if (HostData[j] == '\r') break;
                        if (HostData[j] == '\n') break;
                        j++;
                    }

                    ServerInfo = HostData.Substring(i,j-i);
                }

                //  if (ServerInfo == "*****")  Response.Write("HostData:" + HostData);
                if (ServerInfo.Length > 50)   ServerInfo = ServerInfo.Substring(0, 50);
                 
                foundRows[0]["ServerInfo"] = ServerInfo;
                dt.AcceptChanges();
                 
                //  Next call a function to updatesummary info
                if (ServerInfo != "*****")  UpdateSummaryInfo(dtsum, ServerInfo);
                 
            }
        }
         
         
    void UpdateSummaryInfo(DataTable dtsum, string ServerInfo) 
    {   DataRow[] foundRows = dtsum.Select("ServerInfo='" + ServerInfo + "'");
          
       if (foundRows.Length == 0)
       {  DataRow row1 = dtsum.NewRow();
          row1["ServerInfo"] = ServerInfo;
          row1["Count"] = 1;
          dtsum.Rows.Add(row1);
       }
       else  
       {  foundRows[0]["Count"] = 1 + (System.Int16)foundRows[0]["Count"]; 
          dtsum.AcceptChanges();
       } 
    }
 
  }
}